-- get the addon namespace
local addon, ns = ...
-- get the config values
local cfg = ns.cfg
-- holder for some lib functions
local lib = _G["HEDD_lib"] or CreateFrame("Frame","HEDD_lib")

lib.realX = function(x)
	return x
	--return x*(768.0/cfg.xRes)*cfg.aspectratio/cfg.uiscale
end

lib.realY = function(y)
	return y
	--return y*(768.0/cfg.yRes)/cfg.uiscale
end


lib.HideFrame = function(frame)
	if frame and frame:IsShown() then frame:Hide() end
end

lib.ShowFrame = function(frame)
	if frame and not frame:IsShown() then frame:Show() end
end

lib.bdcolor = function(frame,color)
	if color then
		frame:SetBackdropColor(unpack(color))
		frame:SetBackdropBorderColor(unpack(color))
		frame:Show()
	else
		frame:Hide()
	end
end

lib.hideRuneFrame=function()
	RuneFrame:Hide()
	RuneFrame.Show = hedlib.dummy -- function() end
	RuneFrame.SetPoint = hedlib.dummy --function() end
	RuneFrame.ClearAllPoints = hedlib.dummy --function() end
	RuneFrame.SetAllPoints = hedlib.dummy --function() end
	RuneFrame:UnregisterEvent("RUNE_POWER_UPDATE");
	RuneFrame:UnregisterEvent("RUNE_TYPE_UPDATE");
	RuneFrame:UnregisterEvent("PLAYER_ENTERING_WORLD");
	RuneFrame:SetScript("OnEvent", nil);
	RuneFrame:SetParent(nil)
end

lib.OnUpdateBar = function (self, elapsed) --Heddmain.bar=self
	elapsed = elapsed or 0
	cfg.lastUpdateBar = cfg.lastUpdateBar + elapsed
	if self.force or self.cd>0 then --cfg.lastUpdateBar > cfg.freq 
		self.cd = math.max(0,self.cd - (GetTime() - self.start))
		--self.cd = (self.cd>0) and self.cd or 0
		self.start=GetTime()
		if (self.cd>0) then
			Heddmain.bar.flash=true
			lib.ShowFrame(self)
			self:SetValue(self.cd)
		else
			if SpellFlashCore and Heddmain.bar.flash then
				SpellFlashCore.FlashAction(cfg.spells[self.spell].id,cfg.spellflash,500)
				Heddmain.bar.flash=false
			end
			--[[
			SpellFlashCore.FlashAction(SpellName, color, size, brightness, blink, NoMacros)
			SpellName - (string or number or table) Spell name or global spell id number or table of global spell id numbers.
			color - (1, 1, 1) (string or table or nil) Will accept color tables {r=1.0, g=1.0, b=1.0} or a string with the name of a color that has already been defined. May be nil for "White".
			size - 240 (number or nil) Percent for the flash size or nil for default.
			brightness - 100 (number or nil) Percent for the flash brightness or nil for default.
			blink - false (boolean) If true will make the action button fade in and out.
			NoMacros - false (boolean) If true will skip checking for macros.	]]
			self:SetScript("OnUpdate", nil)
			lib.HideFrame(self)
			self:SetValue(0)
		end
		cfg.lastUpdateBar = 0
		self.force=nil
	end	
end

lib.UpdateBar = function (spell, cd)
	cd =cd or 0
	--Heddmain.bar.pspell=Heddmain.bar.spell
	Heddmain.bar.spell=spell
	Heddmain.bar.start = GetTime()
	Heddmain.bar.cd = cd
	if spell and cfg.spells[spell] then
		cfg.spells[spell].f:Show()
	end
	Heddmain.bar.force=true
	Heddmain.bar:SetScript("OnUpdate", lib.OnUpdateBar)
	lib.OnUpdateBar(Heddmain.bar)
	--cfg.nextUpdate=lib.GetSpellCDNext()
end

lib.nextUpdate = function(cd)
	if cd>0 and cfg.nextUpdate<(GetTime()+cd) then cfg.nextUpdate=GetTime()+cd end
	print(cfg.nextUpdate)
end

lib.SetSpellIcon = function(spell,icon,nothide)
	if cfg.spells[spell] then
		cfg.spells[spell].f:SetWidth(cfg.isize)
		cfg.spells[spell].f:SetHeight(cfg.isize)
		cfg.spells[spell].f.texture = _G["HEDD_"..spell.."_text"] or cfg.spells[spell].f:CreateTexture("HEDD_"..spell.."_text","BACKGROUND")
		cfg.spells[spell].f.texture:SetAllPoints(cfg.spells[spell].f)
		if icon then
			cfg.spells[spell].icon=icon
			cfg.spells[spell].f.texture:SetTexture(cfg.spells[spell].icon)
		else
			if cfg.spells[spell].realid then
				cfg.spells[spell].f.texture:SetTexture(GetSpellTexture(cfg.spells[spell].realid))
			else
				cfg.spells[spell].f.texture:SetTexture(cfg.spells[spell].icon)
			end
		end
		if not nothide then
			cfg.spells[spell].f:Hide()
		end
	else
		print(spell.." not found")
	end
end

lib.FrameResize = function(f,size)
	if not f then return end
	f:SetWidth(size)
	f:SetHeight(size)
end

lib.HRAdd = function(f)
	local hr = f:CreateTexture(nil, "BACKGROUND")
	hr:SetHeight(8)
	hr:SetPoint("LEFT", 5, 0)
	hr:SetPoint("RIGHT", -5, 0)
	hr:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	hr:SetTexCoord(0.81, 0.94, 0.5, 1)
	return hr
end
--[[lib.HeaderAdd = function()
	local frame = CreateFrame("Frame", nil, UIParent)
	frame:Hide()

	local label = frame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
	label:SetPoint("TOP")
	label:SetPoint("BOTTOM")
	label:SetJustifyH("CENTER")
	frame.label=label

	local left = frame:CreateTexture(nil, "BACKGROUND")
	left:SetHeight(8)
	left:SetPoint("LEFT", 3, 0)
	left:SetPoint("RIGHT", label, "LEFT", -5, 0)
	left:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	left:SetTexCoord(0.81, 0.94, 0.5, 1)

	local right = frame:CreateTexture(nil, "BACKGROUND")
	right:SetHeight(8)
	right:SetPoint("RIGHT", -3, 0)
	right:SetPoint("LEFT", label, "RIGHT", 5, 0)
	right:SetTexture("Interface\\Tooltips\\UI-Tooltip-Border")
	right:SetTexCoord(0.81, 0.94, 0.5, 1)
	return frame
end]]

local slider
lib.SliderAdd = function(f,name,mi,ma,val,func)
	slider = CreateFrame("Slider", name, f, "OptionsSliderTemplate")
	slider:SetMinMaxValues(mi, ma)
	slider:SetValue(val)
	slider:SetValueStep(1)
	slider:SetObeyStepOnDrag(true)
	slider:SetWidth(cfg.slider_width)
	slider:SetScript("OnValueChanged", func)
	_G[name.."High"]:SetText(ma)
	_G[name.."Low"]:SetText(mi)
	_G[name.."Text"]:SetText(val)
	return slider
end

lib.SliderSet = function(slider,val)
	slider:SetValue(val)
	_G[slider:GetName().."Text"]:SetText(val)
end

cfg.dropdowns={}
lib.DropDownAdd = function(f,caption, name, values, func)
    local label = f:CreateFontString(nil, "ARTWORK", "GameFontNormal")
    label:SetText(caption)

    local dropDown = _G[name] or CreateFrame("Frame", name, f, "UIDropDownMenuTemplate")
	dropDown.value2id = {}
	dropDown.values = values
    UIDropDownMenu_Initialize(dropDown, function (self, level)
        for k, v in ipairs(values) do
			dropDown.value2id[v] = k
            local info = UIDropDownMenu_CreateInfo()
            info.text, info.value = v, k
            info.func = function(self)
                UIDropDownMenu_SetSelectedID(dropDown, self:GetID())
               -- cfg.dropdowns[config] = self:GetID()
				--print(self:GetName())
				if func then func(dropDown,self:GetID()) end
				--print(values[self:GetID()])
            end
            UIDropDownMenu_AddButton(info, level)
        end
    end)
    UIDropDownMenu_SetWidth(dropDown, 200);
    UIDropDownMenu_JustifyText(dropDown, "LEFT")
    label:SetPoint("BOTTOMLEFT", dropDown, "TOPLEFT", 18, 0)
    return dropDown
end

local frame,icon
lib.AddIconButton = function(f,name,size,id,layer)
	local frame = _G[name] or CreateFrame("Button",name,f)
	frame:SetWidth(size)
	frame:SetHeight(size)
	frame.texture = _G[name.."_texture"] or frame:CreateTexture(name.."_texture",layer or "BACKGROUND")
	frame.texture:SetAllPoints(frame)
	icon=select(3,GetSpellInfo(id))
	if icon then frame.texture:SetTexture(icon) end
	frame:Show()
	return frame
end

local cb 
lib.CheckboxAdd = function(f, name, caption,func)
    cb = CreateFrame("CheckButton", "$parent"..name, f, "OptionsCheckButtonTemplate")
    _G[cb:GetName().."Text"]:SetText(caption or name)
    cb:SetScript("OnClick", func)
    return cb
end